<?php
require_once 'vendor/autoload.php';
use FacebookAds\Api;
use FacebookAds\Object\AdAccount;
use FacebookAds\Object\Fields\CampaignFields;
use FacebookAds\Object\LeadgenForm;
use FacebookAds\Object\Ad;
use Facebook\Facebook;

use GuzzleHttp\Client;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\Ring\Exception\ConnectException;
use GuzzleHttp\Exception\BadResponseException;

$client = new Client();

$meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");

//$enlace = mysqli_connect("localhost", "nataniac_prueba", "Hola123.", "nataniac_prueba");

$enlace = mysqli_connect('localhost', 'nataniad_landing', 'Khgt45Pr4', 'nataniad_landing');


$app_id = '125743388062278';
$app_secret = '9fd018de5392804d7995a101c15823d0';
$access_token = 'EAAByXOn6ckYBAAAqoBJtJk8HJKpXyxq0j0AfjyFLY1dHh3cKizZBlOHegMYve14vZA7ZCr8chR5ieZBLCs0ZAZBr3N30Po9uiyaZB3ipdy61LZAViDuSG9lcmZAmP3LytSmgWNZAYTcV4BaWO8wPJDt5RElnRUZCKbglVleF9qNVxywcgZDZD';
//Api::init($app_id, $app_secret, $access_token);

// The Api object is now available trough singleton
//$api = Api::instance();

$fb = new Facebook([
'app_id' => $app_id,
'app_secret' => $app_secret,
'default_graph_version' => 'v2.10',
]);

$request = $fb->request('GET', '/1142043462606944', array(
'fields' => 'leads.limit(10000){adset_name,field_data,created_time,campaign_name,ad_name}',
),
$access_token
);


// Send the request to Graph
try {
    $response = $fb->getClient()->sendRequest($request);
} catch(Facebook\Exceptions\FacebookResponseException $e) {
    // When Graph returns an error
    echo 'Graph returned an error: ' . $e->getMessage();
    exit;
} catch(Facebook\Exceptions\FacebookSDKException $e) {
    // When validation fails or other local issues
    echo 'Facebook SDK returned an error: ' . $e->getMessage();
    exit;
}
header('Content-Type: text/html; charset=utf-8');
?>

  <!doctype html>
  <!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang=""> <![endif]-->
  <!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8" lang=""> <![endif]-->
  <!--[if IE 8]>         <html class="no-js lt-ie9" lang=""> <![endif]-->
  <!--[if gt IE 8]><!-->
  <html class="no-js" lang="">
  <!--<![endif]-->

  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <title></title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">

  </head>

  <body>
    <?php
            $page = $response->getGraphObject();
            
            $campanias = [
            'Adquisicion_N2_SanJuan_Nov_2017' => ['provincia' => 'San Juan', 'CiudadEmp' => 'SJU'],
            'Adquisicion_N2_Salta_Nov_2017' => ['provincia' => 'Salta', 'CiudadEmp' => 'SAL'],
            'Adquisicion_N2_Tucuman_Nov_2017' => ['provincia' => 'Tucuman', 'CiudadEmp' => 'TUC'],
            'Adquisicion_N2_Mendoza_Nov_2017' => ['provincia' => 'Mendoza', 'CiudadEmp' => 'MZA'],
            'Adquisicion_N2_Neuquen_Nov_2017' => ['provincia' => 'Neuquen', 'CiudadEmp' => 'NEU'],
            'Adquisicion_N2_Cordoba_Nov_2017' => ['provincia' => 'Cordoba', 'CiudadEmp' => 'CBA'],
            'Adquisicion_N2_Comodoro_Nov_2017' => ['provincia' => 'Chubut', 'CiudadEmp' => 'CHU']
            ];
            
            if(!isset($page['leads']))
            {
                echo 'No hay Leads';
                exit;
            }
            
            $page->asArray();
            $leads = $page['leads'];
            $result = [];
            do {
                $leads->asArray();
                // var_dump($leads);
                foreach($leads as $lead){
                    
                    $lead->asArray();
                    $fecha = $lead['created_time']->format('Y-m-d H:i:s');
                    $mes = $meses[$lead['created_time']->format('n')-1];
                    
                    if(isset($lead['field_data'])){
                        
                        $items = $lead['field_data']->asArray();
                        
                        $userLead = array();
                        foreach($items as $item)
                        {
                            switch ($item['name']) {
                                case 'email':
                                    $userLead['email'] = $item['values'][0];
                                    break;
                                
                                case 'first_name':
                                    $userLead['nombre'] = $item['values'][0];
                                    break;
                                
                                case 'last_name':
                                    $userLead['apellido'] = $item['values'][0];
                                    break;
                                
                                case 'phone_number':
                                    $userLead['telefono'] = $item['values'][0];
                                    break;
                                
                                case 'Provincia':
                                    $userLead['provincia'] = $item['values'][0];
                                    break;
                                
                                case 'province':
                                    $province = $item['values'][0];
                                    break;
                        }
                    }
                    
                    /*var_dump($userLead);*/
                    
                    $nombre = $userLead['nombre'];
                    $apellido = $userLead['apellido'];
                    $ciudad = '';
                    $provincia = $campanias[$lead['adset_name']]['provincia'];
                    $codareacelular = '';
                    $celular = '';
                    $email = $userLead['email'];
                    $mensaje = $userLead['telefono'] .' - '.$province;
                    $cliente = '';
                    $sitio = 'www.nataniadirecta.com';
                    $medio = 'cpl';
                    $source = (strpos(strtolower($lead['campaign_name']), strtolower('Instagram')) === false)?'Facebook': 'Instagram';
                    $campaign = $lead['campaign_name'];
                    $utm_content = $lead['ad_name'];
                    $landname = 'FormClientesPotencialesFacebook';
                    $term = $lead['adset_name'];
                    $ciudademp = $campanias[$lead['adset_name']]['CiudadEmp'];
                    $urlorigen = '';
                    $tarjeta = '';
                    $numtarjeta = '';
                    $horcon = '8a10;10a12;12a14;14a16;16a18';
                    $dias = 'LUN;MAR;MIE;JUE;VIE';
                    $producto = 'CASAS;LOTES;DEPARTAMENTOS';
                    $facebook_id = $lead['id'];
                    
                    
                    $body = [ "Nombre"=> $nombre,
                    "Apellido" => $apellido,
                    "Ciudad"=> $provincia,
                    "Provincia"=> $provincia,
                    "CodigoAreaCelular"=> $codareacelular,
                    "Celular"=> $celular,
                    "Producto"=>'1',
                    "Email"=> $email,
                    "Mensaje"=> $mensaje,
                    "Cliente"=> $cliente,
                    "Sitio"=> $sitio,
                    "Medio"=> $medio,
                    "Source"=> $source,
                    "Campaign"=> $campaign,
                    "Contenido"=> $utm_content,
                    "Fecha"=>$lead['created_time']->format('d/m/Y'),
                    "Hora"=> $lead['created_time']->format('h:m:s'),
                    "Landname"=> 'FormClientesPotencialesFacebook_NataniaDirecta',
                    "SitioDestino"=> 'http://www.nataniadirecta.com',
                    "Term" => $term,
                    "CiudadEmp" => $ciudademp,
                    "UrlOrigen" => $urlorigen,
                    "TarjetaCredito" => $tarjeta,
                    "NumeroTarjetaCredito" => $numtarjeta,
                    "EsVentaDirecta" => 'True',
                    "FacebookId" => $facebook_id
                    ];
                    
                    $busqueda = 'SELECT idcliente FROM contactos WHERE facebook_id='.$lead['id'];
                    
                    $resultado = mysqli_query($enlace, $busqueda);
                    $obj = $resultado->fetch_object();
                    
                    $body[ "idcliente"] = $obj->idcliente;
                    
                    $result[] = $body;
                    
                    
                }
                
            }
        } while ($leads = $fb->next($leads));
        
        echo json_encode($result);
        ?>

  </body>

  </html>