<?php
require_once 'vendor/autoload.php';
require_once '../log.php';

use FacebookAds\Api;
use FacebookAds\Object\AdAccount;
use FacebookAds\Object\Fields\CampaignFields;
use FacebookAds\Object\LeadgenForm;
use FacebookAds\Object\Ad;
use Facebook\Facebook;

use GuzzleHttp\Client;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\Ring\Exception\ConnectException;
use GuzzleHttp\Exception\BadResponseException;
$client = new Client(['verify'=>false]);

$meses = array("Enero","Febrero","Marzo","Abril","Mayo","Junio","Julio","Agosto","Septiembre","Octubre","Noviembre","Diciembre");

//$enlace = mysqli_connect("localhost", "nataniac_prueba", "Hola123.", "nataniac_prueba");

$enlace = mysqli_connect('localhost', 'nataniad_landing', 'Khgt45Pr4', 'nataniad_landing');


$app_id = '1001409576662084';
$app_secret = '49bbbd3f11d5012e798068b64d29674e';
$access_token = 'EAAOOxtYXdEQBAOlMj5KyMgRja47yUaRClpRYQnGEtTHpGKY14kNFupTt8lYynBO2Ih6MfkxtGfSjFD3X4KsGMukpQ5wWF3LjMSgpw81AP4jg4TdpliV9yhKE4a8mMFqlSuFfrWPqzZBytZAJZApMrkW4iXg824ZD';
//Api::init($app_id, $app_secret, $access_token);

// The Api object is now available trough singleton
//$api = Api::instance();

$fb = new Facebook([
'app_id' => $app_id,
'app_secret' => $app_secret,
'default_graph_version' => 'v2.10',
]);

$request = $fb->request('GET', '/320876288415414', array(
'fields' => 'leads.limit(2000){adset_name,field_data,created_time,campaign_name,ad_name,platform}',
),
$access_token
);


// Send the request to Graph
try {
    $response = $fb->getClient()->sendRequest($request);
} catch(Facebook\Exceptions\FacebookResponseException $e) {
    // When Graph returns an error
    echo 'Graph returned an error: ' . $e->getMessage();
    exit;
} catch(Facebook\Exceptions\FacebookSDKException $e) {
    // When validation fails or other local issues
    echo 'Facebook SDK returned an error: ' . $e->getMessage();
    exit;
}
?>

  <!doctype html>
  <!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang=""> <![endif]-->
  <!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8" lang=""> <![endif]-->
  <!--[if IE 8]>         <html class="no-js lt-ie9" lang=""> <![endif]-->
  <!--[if gt IE 8]><!-->
  <html class="no-js" lang="">
  <!--<![endif]-->

  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <title></title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">

  </head>

  <body>
    <?php
            echo '<pre>';
            $page = $response->getGraphObject();
            
            $provincias = [
                'san_juan' => ['provincia' => 'San Juan', 'CiudadEmp' => 'SJU'],
                'salta' => ['provincia' => 'Salta', 'CiudadEmp' => 'SAL'],
                'tucuman' => ['provincia' => 'Tucuman', 'CiudadEmp' => 'TUC'],
                'mendoza' => ['provincia' => 'Mendoza', 'CiudadEmp' => 'MZA'],
                'neuquen' => ['provincia' => 'Neuquen', 'CiudadEmp' => 'NEU'],
                'cordoba' => ['provincia' => 'Cordoba', 'CiudadEmp' => 'CBA'],
                'chubut' => ['provincia' => 'Chubut', 'CiudadEmp' => 'CHU'],
                'la_pampa' => ['provincia' => 'La pampa', 'CiudadEmp' => 'LPA']
                ];
            
            echo '<br>Leads:<br>';
            
            if(!isset($page['leads']))
            {
                echo 'No hay Leads';
                exit;
            }
            
            $page->asArray();
            $leads = $page['leads'];
            
            do {
                $leads->asArray();
                // var_dump($leads);
                foreach($leads as $lead){
                    
                    $lead->asArray();
                    
                    echo 'ID: '.$lead['id'].'<br>';
                    
                    $busqueda = 'SELECT count(*) as cantidad FROM contactos WHERE facebook_id='.$lead['id'];
                    
                    $resultado = mysqli_query($enlace, $busqueda);
                    $obj = $resultado->fetch_object();
                    if($obj->cantidad > 0)
                    {
                        echo 'Preexistente<br>';
                        continue;
                    }
                    $fecha = $lead['created_time']->setTimeZone(new DateTimeZone('America/Argentina/Cordoba'))->format('Y-m-d H:i:s');
                    $mes = $meses[$lead['created_time']->format('n')-1];
                    
                    if(isset($lead['field_data'])){

                        $items = $lead['field_data']->asArray();
                        
                        $userLead = array();
                        foreach($items as $item)
                        {
                            switch ($item['name']) {
                                case 'email':
                                    $userLead['email'] = $item['values'][0];
                                    break;
                                
                                case 'first_name':
                                    $userLead['nombre'] = $item['values'][0];
                                    break;

                                case 'Nombre':
                                    $userLead['nombre'] = $item['values'][0];
                                    break;
                                
                                case 'last_name':
                                    $userLead['apellido'] = $item['values'][0];
                                    break;
                                
                                case 'Apellido':
                                    $userLead['apellido'] = $item['values'][0];
                                    break;
                                
                                case 'phone_number':
                                case 'celular_(con_15)':
                                case 'celular':
                                case 'Telefono':
                                    $userLead['telefono'] = $item['values'][0];
                                    break;
                                
                                case 'elige_tu_ciudad':
                                    $userLead['ciudad'] = $item['values'][0];
                                    break;
                                
                                case 'comentarios':
                                    $userLead['comentario'] = $item['values'][0];
                                    break;
                                
                                case 'province':
                                case 'provincia':
                                    // $province = $item['values'][0];
                                    $province = '';
                                    $userLead['provincia'] = $item['values'][0];
                                    break;

                                case 'cód._de_área_(con_0)':
                                case 'cod_area':
                                    $userLead['cod_area'] = $item['values'][0];
                                    break;
                        }
                    }
                    
                    /*var_dump($userLead);*/
                    
                    $nombre = $userLead['nombre'];
                    $apellido = $userLead['apellido'];
                    $ciudad = '';
                    //$provincia = 'Cordoba';
                    $codareacelular = '';
                    $celular = '';
                    $email = $userLead['email'];
                    $mensaje = $userLead['cod_area'].' '.$userLead['telefono'] .' - '.$province;
                    $cliente = '';
                    $sitio = 'www.nataniadirecta.com';
                    $medio = 'cpl';
                    $source = (strpos(strtolower($lead['platform']), strtolower('ig')) === false)?'Facebook': 'Instagram';
                    $campaign = $lead['campaign_name'];
                    $utm_content = $lead['ad_name'];
                    $landname = 'FB-IG_Lead-ads_VC-Directa';
                    $term = $lead['adset_name'];
                    $ciudademp = 'CBA';
                    $urlorigen = '';
                    $tarjeta = '';
                    $numtarjeta = '';
                    $horcon = '8a10;10a12;12a14;14a16;16a18';
                    $dias = 'LUN;MAR;MIE;JUE;VIE';
                    //$producto = 'CASAS;LOTES;DEPARTAMENTOS';
                    $facebook_id = $lead['id'];

                    $province = '';
                    
					if (strrpos($lead['ad_name'], 'Cordoba') == true) {
					$provincia = "Cordoba";
					}
					else if (strrpos($lead['ad_name'], 'Mendoza') == true) {
					$provincia = "Mendoza";
					}
					else if (strrpos($lead['ad_name'], 'Salta') == true) {
					$provincia = "Salta";
					}
					else if (strrpos($lead['ad_name'], 'LA_') == true) {
					$provincia = "Salta";
					}
					else if (strrpos($lead['ad_name'], 'Neuquen') == true) {
					$provincia = "Neuquen";
					}
					else if (strrpos($lead['ad_name'], 'QN_') == true) {
					$provincia = "Neuquen";
					}
					else if (strrpos($lead['ad_name'], 'Tucuman') == true) {
					$provincia = "Tucuman";
					}
					else if (strrpos($lead['ad_name'], 'UC_') == true) {
					$provincia = "Tucuman";
					}
					else if (strrpos($lead['ad_name'], 'Juan') == true) {
					$provincia = "San Juan";
					}
					else if (strrpos($lead['ad_name'], 'HU_') == true) {
					$provincia = "Chubut";
					}
					else if (strrpos($lead['ad_name'], 'omodoro_') == true) {
					$provincia = "Chubut";
					}
					else if (strrpos($lead['ad_name'], 'Santiago-del-Estero') == true) {
					$provincia = "Santiago del Estero";
					}
					else {
					$provincia = 'Cordoba';
					}

					if (strrpos($lead['ad_name'], 'Depto') == true) {
					$producto = "Depto";
					}
					else if (strrpos($lead['ad_name'], 'Casa') == true) {
					$producto = "Casa";
					}
					else if (strrpos($lead['ad_name'], 'Local') == true) {
					$producto = "Local";
					}
					else if (strrpos($lead['ad_name'], 'Lote') == true) {
					$producto = "Lote";
					}
					else {
					$producto = '';
					}
                    
                    $SQL = 'INSERT INTO contactos (nombre, apellido, email, ciudad, provincia, codareacelular, celular, mensaje, utm_campaign, utm_term, utm_medium, utm_source, horcon, landing, producto, ciudademp, dias, idcliente, utm_content, cliente, facebook_id, fecha)
                            VALUES("'.$nombre.'", "'.$apellido.'", "'.$email.'", "'.$ciudad.'", "'.$provincia.'", "'.$codareacelular.'", "'.$celular.'", "'.$mensaje.'", "'.$term.'", "'.$term.'", "'.$medio.'", "'.$source.'", "'.$horcon.'", "'.$landname.'", "'.$producto.'", "'.$ciudademp.'", "'.$dias.'", "'.$idcliente.'", "'.$utm_content.'", "'.$cliente.'", "'.$facebook_id.'", "'.$fecha.'")';
                    
                    mysqli_query($enlace,$SQL);
                    
                    $id = mysqli_insert_id($enlace);
                    
                    $body = [ "Nombre"=> $nombre,
                    "Apellido" => $apellido,
                    "Ciudad"=> $provincia,
                    "Provincia"=> $provincia,
                    "CodigoAreaCelular"=> $codareacelular,
                    "Celular"=> $celular,
                    "Producto"=>$producto,
                    "Email"=> $email,
                    "Mensaje"=> $mensaje,
                    "Cliente"=> $cliente,
                    "Sitio"=> $sitio,
                    "Medio"=> $medio,
                    "Source"=> $source,
                    "Campaing"=> $campaign,
                    "Contenido"=> $utm_content,
                    "Fecha"=>$lead['created_time']->format('d/m/Y'),
                    "Hora"=> $lead['created_time']->format('H:i:s'),
                    "Landname"=> $landname,
                    "SitioDestino"=> 'http://www.nataniadirecta.com',
                    "Term" => $term,
                    "CiudadEmp" => $ciudademp,
                    "UrlOrigen" => $urlorigen,
                    "TarjetaCredito" => $tarjeta,
                    "NumeroTarjetaCredito" => $numtarjeta,
                    "EsVentaDirecta" => 'True'
                    ];

                    echo json_encode($body);
                    //exit;
                    
                    $estado_encuesta = 'inicial'; //cambiar por encuestando
                    // Esto te da el Telefono posta
                    $telefono = '54'.preg_replace('/0/', '', $codareacelular, 1).preg_replace('/15/', '', $celular, 1);
                    //$telefono='';
                    
                    $idcliente = 'No se pudo guardar';
                    
                    try {
                        $response = $client->request('POST', 'https://crm.ecipsa.com:5001/ServiciosLeximCRM/v1/oportunidad', [
                        'form_params' => $body
                        ]);
                        $respuesta = json_decode($response->getBody());
                        $idcliente = $respuesta->Name;
                        var_dump($idcliente);
                    } catch( Exception $ex ) {
                        $respuesta = $ex->getMessage();
                    }

                    new LogEcipsa($id, $respuesta);
                    
                    
                    //var_dump($idcliente);
                    //var_dump($id);
                    $SQL = 'UPDATE contactos SET idcliente = "'.$idcliente.'" WHERE facebook_id='.$facebook_id;
                    mysqli_query($enlace,$SQL);
                    
                }
                
            }
        } while ($leads = $fb->next($leads));
        
        echo '</pre>';
        ?>

  </body>

  </html>